<!-- RvW's changes:
  back to start page link (id = title)
  menu now implemented with divs instead of ul/li
  no footer
  google analytics code (with parameter)
  removed title tag (tooltip over paragraphs with title) 
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:elml="http://www.elml.ch"
  xmlns="http://www.w3.org/1999/xhtml" version="2.0">
  <xsl:import href="../../../core/presentation/online/elml.xsl"/>
  <xsl:import href="biblio_apa.xsl"/>
  <xsl:param name="layout" select="'wiss-schreiben'"/>
  <xsl:param name="css_framework" select="'yaml'"/>

  <xsl:template name="elml:LayoutBody">
    <xsl:param name="prev">
      <xsl:call-template name="elml:prev_file"/>
    </xsl:param>
    <xsl:param name="next">
      <xsl:call-template name="elml:next_file"/>
    </xsl:param>
    <xsl:if test="$google_analytics='yes'">
      <script type="text/javascript">
        if (window.location.href.search(/fernuni.ch/) != -1)
        { 
          var _gaq = _gaq || [];
          _gaq.push(['_setAccount', 'UA-23014206-1']);
          _gaq.push(['_trackPageview']);
        
          (function() {
          var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
          ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
          var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
          })();
        }
      </script>
    </xsl:if>
    <body onload="adjust_size()">
      <!-- rvw -->
      <a name="top"/>
      <div id="page_margins">
        <div id="page">
          <div id="header">
            <xsl:attribute name="class">
              <!-- rvw -->
              <xsl:value-of select="/elml:lesson/@label"/>
            </xsl:attribute>
            <div id="topnav">
              <xsl:call-template name="elml:LayoutBodySkiplinks"/>
            </div>
            <!-- back/startpage navigation -->
            <a href="../../../index.html">
              <img id="nav_startpage" src="../../../_templates/{$layout}/images/transp.png"
                width="190" height="30"/>
            </a>
            <!-- back/forward buttons, top of page -->
            <div id="nav_arrows_top">
              <xsl:choose>
                <xsl:when test="$prev='none.html'">
                  <img src="../../../_templates/{$layout}/navigation/prev-.png" height="14"
                    width="15" title="keine vorhergehenden Seite" border="0"/>
                </xsl:when>
                <xsl:otherwise>
                  <a href="{$prev}">
                    <img src="../../../_templates/{$layout}/navigation/prev.png" height="14"
                      width="15" title="zur vorhergehenden Seite" border="0"/>
                  </a>
                </xsl:otherwise>
              </xsl:choose>
              <a href="#top">
                <img src="../../../_templates/{$layout}/navigation/up.png" height="15" width="15"
                  title="Seitenanfang" border="0"/>
              </a>
              <xsl:choose>
                <xsl:when test="$next='none.html'">
                  <img src="../../../_templates/{$layout}/navigation/next-.png" height="14"
                    width="15" title="keine weitere Seite" border="0"/>
                </xsl:when>
                <xsl:otherwise>
                  <a href="{$next}">
                    <img src="../../../_templates/{$layout}/navigation/next.png" height="14"
                      width="15" title="zur naechsten Seite" border="0"/>
                  </a>
                </xsl:otherwise>
              </xsl:choose>
            </div>
          </div>

          <div id="main">
            <!-- left column: navigation and search -->
            <div id="col1">
              <xsl:attribute name="class">
                <!-- rvw -->
                <xsl:value-of select="/elml:lesson/@label"/>
              </xsl:attribute>
              <div id="col1_content" class="nav">
                <xsl:call-template name="elml:navigation"/>
              </div>
              <div id="quicklinks">
                <xsl:choose>
                  <xsl:when test="/elml:lesson/@label = 'zotero'">
                    <a href="../../../zotero.pdf" target="_blank">PDF-Druckversion</a><br/>                    
                  </xsl:when>
                </xsl:choose>
                <a href="mailto:etools@fernuni.ch?subject=Wissenschaftliches Schreiben:%20feedback">Kontakt / Fehler melden</a><br/>
                <a href="http://creativecommons.org/licenses/by-nc-sa/2.5/ch/" target="_blank">Copyright</a><br/>
              </div>
            </div>

            <!-- column 3: main content -->
            <div id="col3">
              <div id="col3_content">
                <noscript>
                <div id="javamsg" class="box" style="padding-left:10px">
                  <span style="color:red; font-weight:bold">Bitte aktivieren Sie <span
                      style="text-decoration:blink">JavaScript</span> in Ihrem Browser. Dieses
                    Lernprogramm kann sonst nicht korrekt funktionieren. </span>
                  <a href="http://www.google.ch/search?hl=de&amp;source=hp&amp;biw=&amp;bih=&amp;q=javascript+im+browser+aktivieren&amp;btnG=Google-Suche" target="_blank">Wie geht das?</a><br/>
                  <br/> Anschliessend klicken Sie bitte <a href="javascript:location.reload()"
                    >hier</a>, um die Seite neu zu laden. </div>
                </noscript>

                <!-- main page content -->
                <xsl:call-template name="elml:LayoutBodyContent"/>

                <!-- back/forward buttons, bottom of page -->
                <div id="nav_arrows_bottom">
                  <xsl:choose>
                    <xsl:when test="$prev='none.html'">
                      <img src="../../../_templates/{$layout}/navigation/prev-.png" height="14"
                        width="15" title="keine vorhergehenden Seite" border="0"/>
                    </xsl:when>
                    <xsl:otherwise>
                      <a href="{$prev}">
                        <img src="../../../_templates/{$layout}/navigation/prev.png" height="14"
                          width="15" title="zur vorhergehenden Seite" border="0"/>
                      </a>
                    </xsl:otherwise>
                  </xsl:choose>
                  <a href="#top">
                    <img src="../../../_templates/{$layout}/navigation/up.png" height="15"
                      width="15" title="Seitenanfang" border="0"/>
                  </a>
                  <xsl:choose>
                    <xsl:when test="$next='none.html'">
                      <img src="../../../_templates/{$layout}/navigation/next-.png" height="14"
                        width="15" title="keine weitere Seite" border="0"/>
                    </xsl:when>
                    <xsl:otherwise>
                      <a href="{$next}">
                        <img src="../../../_templates/{$layout}/navigation/next.png" height="14"
                          width="15" title="zur naechsten Seite" border="0"/>
                      </a>
                    </xsl:otherwise>
                  </xsl:choose>
                </div>

              </div>
            </div>
          </div>
        </div>
      </div>
    </body>
  </xsl:template>

  <!-- RvW: new parameter -->  
  <xsl:param name="google_analytics">
    <xsl:choose>
      <xsl:when test="document($config_file)/elml:config/elml:online/elml:google_analytics">
        <xsl:value-of select="document($config_file)/elml:config/elml:online/elml:google_analytics"/>
      </xsl:when>
      <xsl:when test="document($config_file)/config/online/google_analytics">
        <xsl:value-of select="document($config_file)/config/online/google_analytics"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="document($config_file_default)/elml:config/elml:online/elml:google_analytics"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:param>
  
  <!-- RvW: removed title tag (tooltip over paragraphs with title) -->
  <xsl:template match="elml:paragraph">
    <xsl:param name="display">
      <xsl:call-template name="elml:display"/>
    </xsl:param>
    <xsl:if test="$display='yes'">
      <xsl:call-template name="elml:Title"/>
      <xsl:if test="@icon and not($layout='none')">
        <img src="../../../_templates/{$layout}/icons/{@icon}.{$icon_filetype}" title="{@icon}" alt="{@icon}" class="icon"/>
      </xsl:if>
      <p>
        <xsl:call-template name="elml:CSS_Class"/>
        <!--
          <xsl:if test="@title">
          <xsl:attribute name="title">
          <xsl:value-of select="@title"/>
          </xsl:attribute>
          </xsl:if>
        -->
        <xsl:call-template name="elml:Label"/>
        <xsl:apply-templates/>
      </p>
    </xsl:if>
  </xsl:template>
  
  <!-- RvW: modified to generate "Startseite" link -->
  <xsl:template name="elml:navigation">
    <xsl:if test="$use_navigation='yes'">
      <div class="navigation" id="submenu">
        <div id="title">
          <!-- rvw -->
          <xsl:attribute name="onclick">
            <xsl:text>document.location.href='../../../index.html'</xsl:text>
          </xsl:attribute>
          <xsl:text>Startseite</xsl:text>
        </div>
        <!-- rvw -->
        <xsl:call-template name="elml:navigation_start"/>
      </div>
    </xsl:if>
  </xsl:template>

  <!-- RvW: modified to generate navigation items with divs (not ul/li) -->
  <xsl:template match="elml:lesson" mode="navigation_lesson">
    <xsl:param name="filename"/>
    <xsl:param name="actual_lesson"/>
    <xsl:param name="navact">
      <xsl:if
        test="($actual_lesson=/elml:lesson/@label) and ($filename = concat('index', $filename_suffix))">
        <xsl:text>_act</xsl:text>
      </xsl:if>
    </xsl:param>
    <xsl:choose>
      <xsl:when test="$css_framework='yaml'">
        <div id="lessontitle">
          <xsl:call-template name="elml:nav_item_link">
            <xsl:with-param name="filename" select="$filename"/>
            <xsl:with-param name="navact" select="$navact"/>
            <xsl:with-param name="isnavigation">yes</xsl:with-param>
          </xsl:call-template>
        </div>
        <xsl:if
          test="(document($config_file)/elml:config/elml:modules/elml:course[child::node()=$transformlesson_label]/@subnavigation='yes') or ($actual_lesson=/elml:lesson/@label)">
          <div class="navigation" id="nav_unit">
            <xsl:apply-templates
              select="elml:unit | elml:selfAssessment | elml:summary | elml:furtherReading | elml:glossary | elml:listOfFigures | elml:listOfTables | elml:index | elml:bibliography | elml:metadata"
              mode="navigation_unit">
              <xsl:with-param name="filename" select="$filename"/>
            </xsl:apply-templates>
          </div>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <li class="{elml:get_linkcssclass($navact)}">
          <xsl:call-template name="elml:nav_item_link">
            <xsl:with-param name="filename" select="$filename"/>
            <xsl:with-param name="navact" select="$navact"/>
            <xsl:with-param name="isnavigation">yes</xsl:with-param>
          </xsl:call-template>
          <xsl:if
            test="(document($config_file)/elml:config/elml:modules/elml:course[child::node()=$transformlesson_label]/@subnavigation='yes') or ($actual_lesson=/elml:lesson/@label)">
            <ul class="navigation nav_unit">
              <xsl:apply-templates
                select="elml:unit | elml:selfAssessment | elml:summary | elml:furtherReading | elml:glossary | elml:listOfFigures | elml:listOfTables | elml:index | elml:bibliography | elml:metadata"
                mode="navigation_unit">
                <xsl:with-param name="filename" select="$filename"/>
              </xsl:apply-templates>
            </ul>
          </xsl:if>
        </li>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <!-- RvW: modified to generate navigation items with divs (not ul/li) -->
  <xsl:template name="elml:nav_item_link">
    <xsl:param name="navact"/>
    <xsl:param name="filename"/>
    <xsl:param name="isnavigation"/>
    <xsl:param name="actual_lesson"/>
    <xsl:param name="filenameactual">
      <xsl:call-template name="elml:Label_param"/>
    </xsl:param>
    <xsl:choose>
      <xsl:when
        test="$navact='_act' and (not($css_framework='yaml') or ($css_framework='yaml' and $isnavigation='yes'))">
        <xsl:attribute name="class">
          <xsl:text>navigationActual</xsl:text>
        </xsl:attribute>
        <xsl:call-template name="elml:Kapitel">
          <xsl:with-param name="isnavigation" select="$isnavigation"/>
        </xsl:call-template>
        <xsl:if
          test="contains($filenameactual, 'unit_') and contains($optional_units, substring-after(substring-before($filenameactual, $filename_suffix), 'unit_'))">
          <xsl:value-of select="$name_optionalunits_symbol"/>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:if
          test="$navact='_act' or (name='learningObject' and contains($filename, @label)) or ($multiple='on' and $actual_lesson=/elml:lesson/@label)">
          <xsl:attribute name="id">
            <xsl:text>current</xsl:text>
          </xsl:attribute>
        </xsl:if>
        <xsl:choose>
          <!-- rvw : new class -->
          <xsl:when
            test="(name(.)='unit') and not(count(elml:learningObject)=1) and (($pagebreak_level='unit') or ($pagebreak_level='lo')) and (($filename = $filenameactual) or contains($filename,@label))">
            <xsl:attribute name="class">
              <xsl:text>navigationLink_on</xsl:text>
            </xsl:attribute>
          </xsl:when>
          <xsl:otherwise>
            <xsl:attribute name="class">
              <xsl:text>navigationLink</xsl:text>
            </xsl:attribute>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:attribute name="onclick">
          <xsl:text>document.location.href='</xsl:text>
          <xsl:if test="$multiple='on'">
            <xsl:text>../../../</xsl:text>
            <xsl:value-of select="/elml:lesson/@label"/>
            <xsl:text>/</xsl:text>
            <xsl:value-of select="$lang"/>
            <xsl:text>/html/</xsl:text>
          </xsl:if>
          <xsl:if
            test="$isnavigation='toc' and $pagebreak_level='lo' and (name()='clarify' or name()='look' or name()='act')">
            <xsl:value-of select="../../@label"/>
            <xsl:text>_</xsl:text>
            <xsl:choose>
              <xsl:when test="../@label">
                <xsl:value-of select="../@label"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="name(..)"/>
                <xsl:if test="name(..)='learningObject'">
                  <xsl:number level="single" count="elml:learningObject"/>
                </xsl:if>
              </xsl:otherwise>
            </xsl:choose>
            <xsl:value-of select="$filename_suffix"/>
          </xsl:if>
          <xsl:call-template name="elml:Label_param_withfilename"/>
          <xsl:text>'</xsl:text>
        </xsl:attribute>
        <xsl:call-template name="elml:Kapitel">
          <xsl:with-param name="isnavigation" select="$isnavigation"/>
        </xsl:call-template>
        <xsl:if
          test="contains($filenameactual, 'unit_') and contains($optional_units, substring-after(substring-before($filenameactual, $filename_suffix), 'unit_'))">
          <xsl:value-of select="$name_optionalunits_symbol"/>
        </xsl:if>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template
    match="elml:unit | elml:selfAssessment | elml:summary | elml:furtherReading | elml:glossary | elml:listOfFigures | elml:listOfTables | elml:index | elml:bibliography | elml:metadata"
    mode="navigation_unit">
    <xsl:param name="filename"/>
    <xsl:param name="filenameactual">
      <xsl:call-template name="elml:Label_param"/>
    </xsl:param>
    <xsl:param name="display">
      <xsl:call-template name="elml:display"/>
    </xsl:param>
    <xsl:param name="navact">
      <xsl:choose>
        <xsl:when test="$filename = $filenameactual">
          <xsl:text>_act</xsl:text>
        </xsl:when>
        <xsl:when test="(name(.)='entry') and ($filename = concat('index', $filename_suffix))">
          <xsl:text>_act</xsl:text>
        </xsl:when>
        <xsl:otherwise>
          <xsl:text/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:param>
    <xsl:if test="$display='yes'">
      <xsl:choose>
        <xsl:when
          test="(name(.)='unit') and not(count(elml:learningObject)=1) and (($pagebreak_level='unit') or ($pagebreak_level='lo')) and (($filename = $filenameactual) or contains($filename,@label))">
          <div>
            <!-- ??? -->
            <xsl:call-template name="elml:nav_item_link">
              <xsl:with-param name="filename" select="$filename"/>
              <xsl:with-param name="navact" select="$navact"/>
              <xsl:with-param name="isnavigation">yes</xsl:with-param>
            </xsl:call-template>
          </div>
        </xsl:when>
        <xsl:otherwise>
          <div class="{elml:get_linkcssclass($navact)}">
            <xsl:call-template name="elml:nav_item_link">
              <xsl:with-param name="filename" select="$filename"/>
              <xsl:with-param name="navact" select="$navact"/>
              <xsl:with-param name="isnavigation">yes</xsl:with-param>
            </xsl:call-template>
          </div>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:if
        test="(name(.)='unit') and not(count(elml:learningObject)=1) and (($pagebreak_level='unit') or ($pagebreak_level='lo')) and (($filename = $filenameactual) or contains($filename,@label))">
        <div class="navigation" id="nav_lo">
          <xsl:apply-templates
            select="elml:learningObject | elml:selfAssessment | elml:summary | elml:furtherReading "
            mode="navigation_lo">
            <xsl:with-param name="filename" select="$filename"/>
          </xsl:apply-templates>
        </div>
      </xsl:if>
    </xsl:if>
  </xsl:template>

  <xsl:template
    match="elml:entry | elml:learningObject | elml:selfAssessment | elml:summary | elml:furtherReading"
    mode="navigation_lo">
    <xsl:param name="filename"/>
    <xsl:param name="filenameactual">
      <xsl:call-template name="elml:Label_param"/>
    </xsl:param>
    <xsl:param name="navact">
      <xsl:choose>
        <xsl:when test="$filename = $filenameactual">
          <xsl:text>_act</xsl:text>
        </xsl:when>
        <xsl:when
          test="(name(.)='entry') and ($filename = concat('unit_',parent::elml:unit/@label,$filename_suffix)) and ($pagebreak_level='lo')">
          <xsl:text>_act</xsl:text>
        </xsl:when>
        <xsl:otherwise>
          <xsl:text/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:param>
    <div class="{elml:get_linkcssclass($navact)}">
      <xsl:call-template name="elml:nav_item_link">
        <xsl:with-param name="filename" select="$filename"/>
        <xsl:with-param name="navact" select="$navact"/>
        <xsl:with-param name="isnavigation">yes</xsl:with-param>
      </xsl:call-template>
    </div>
  </xsl:template>

  <!-- redefinition of templates for Units with only one learningObject -->
  <xsl:template name="elml:LayoutBodyContent">
    <!-- Skiplink-Anchor: Content -->
    <xsl:choose>
      <xsl:when test="((name(.)='clarify') or (name(.)='look') or (name(.)='act')) and not(@title)"/>
      <!-- Delete this statement if you want a default title for the entry element -->
      <xsl:when test="(name(.)='entry') and not(@title)">
        <span>
          <xsl:call-template name="elml:Label"/>
        </span>
      </xsl:when>
      <xsl:when
        test="($pagebreak_level='lesson') and ((name(.)='clarify') or (name(.)='look') or (name(.)='act'))">
        <h4>
          <xsl:call-template name="elml:Label"/>
          <xsl:call-template name="elml:Kapitel"/>
        </h4>
      </xsl:when>
      <xsl:when
        test="(($pagebreak_level='lesson') and ((name(.)='learningObject') or ((name(parent::*)='unit') and ((name(.)='entry') or (name(.)='goals') or (name(.)='selfAssessment') or (name(.)='summary') or (name(.)='furtherReading'))))) or (($pagebreak_level='unit') and ((name(.)='clarify') or (name(.)='look') or (name(.)='act')))">
        <h3>
          <xsl:call-template name="elml:Label"/>
          <xsl:call-template name="elml:Kapitel"/>
        </h3>
      </xsl:when>
      <xsl:when
        test="(name(.)='clarify') or (name(.)='look') or (name(.)='act') or (name(.)='entry') or (name(.)='goals') or (($pagebreak_level='unit') and ((name(.)='learningObject') or ((name(parent::*)='unit') and ((name(.)='selfAssessment') or (name(.)='summary') or (name(.)='furtherReading'))))) or (($pagebreak_level='lesson') and ((name(.)='unit') or (name(.)='glossary') or (name(.)='listOfFigures') or (name(.)='listOfTables') or (name(.)='index') or (name(.)='bibliography') or (name(.)='metadata') or ((name(parent::*)='lesson') and ((name(.)='selfAssessment') or (name(.)='summary') or (name(.)='furtherReading'))) ))">
        <h2>
          <xsl:call-template name="elml:Label"/>
          <xsl:call-template name="elml:Kapitel"/>
        </h2>
      </xsl:when>
      <xsl:otherwise>
        <xsl:if test="@title != ''">
          <!-- rvw: don't generate h1 tag when title is empty -->
          <h1>
            <span class="underline">
              <xsl:call-template name="elml:Label"/>
              <xsl:call-template name="elml:Kapitel"/>
            </span>
          </h1>
        </xsl:if>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="name(.)='unit' and contains($optional_units, @label)">
      <p class="tutor">
        <xsl:value-of select="$name_optionalunits_text"/>
      </p>
    </xsl:if>
    <xsl:if test="@role='tutor'">
      <p class="tutor">
        <xsl:value-of select="$name_tutoronly"/>
      </p>
    </xsl:if>
    <xsl:choose>
      <xsl:when test="name(.)='glossary'">
        <dl class="glossary">
          <xsl:apply-templates>
            <xsl:sort select="@term" order="ascending" lang="{$lang}"/>
          </xsl:apply-templates>
        </dl>
      </xsl:when>
      <xsl:when test="name(.)='listOfTables' and not(//elml:table)">
        <p>
          <xsl:value-of select="$name_tables"/>
          <xsl:value-of select="$name_glossary_empty"/>
        </p>
      </xsl:when>
      <xsl:when test="name(.)='listOfTables'">
        <ul>
          <xsl:call-template name="elml:CSS_Class"/>
          <xsl:for-each select="//elml:table">
            <li>
              <xsl:call-template name="elml:Legend_listof"/>
              <xsl:if test="@bibIDRef">
                <xsl:call-template name="elml:BibliographyRef"/>
              </xsl:if>
            </li>
          </xsl:for-each>
        </ul>
      </xsl:when>
      <xsl:when test="name(.)='listOfFigures' and not(//elml:multimedia)">
        <p>
          <xsl:value-of select="$name_figures"/>
          <xsl:value-of select="$name_glossary_empty"/>
        </p>
      </xsl:when>
      <xsl:when test="name(.)='listOfFigures'">
        <ul>
          <xsl:call-template name="elml:CSS_Class"/>
          <xsl:for-each select="//elml:multimedia">
            <xsl:if test="not(@type='div')">
              <li>
                <xsl:call-template name="elml:Legend_listof"/>
                <xsl:if test="@bibIDRef">
                  <xsl:call-template name="elml:BibliographyRef"/>
                </xsl:if>
                <xsl:text> (</xsl:text>
                <xsl:value-of select="@type"/>
                <xsl:text>)</xsl:text>
              </li>
            </xsl:if>
          </xsl:for-each>
        </ul>
      </xsl:when>
      <xsl:when test="name(.)='index' and not(//elml:indexItem)">
        <p>
          <xsl:value-of select="$name_index"/>
          <xsl:value-of select="$name_glossary_empty"/>
        </p>
      </xsl:when>
      <xsl:when test="name(.)='index'">
        <ul class="index_list">
          <xsl:for-each-group select="//elml:indexItem"
            group-by="(if (@affiliatedTo) then  @affiliatedTo else .)">
            <xsl:sort select="." order="ascending" case-order="lower-first"/>
            <li>
              <xsl:value-of select="current-grouping-key()"/>
              <xsl:text>: </xsl:text>
              <xsl:for-each select="current-group()">
                <xsl:variable name="indexID">
                  <xsl:value-of select="generate-id()"/>
                </xsl:variable>
                <a>
                  <xsl:attribute name="href">
                    <xsl:for-each
                      select="ancestor::node()[name()='learningObject' or name()='selfAssessment' or name()='furtherReading' or name()='unit' or name()='lesson'][1]">
                      <xsl:variable name="filename_index">
                        <xsl:call-template name="elml:Label_param_withfilename"/>
                      </xsl:variable>
                      <xsl:choose>
                        <xsl:when test="contains($filename_index, '#')">
                          <xsl:value-of
                            select="concat(substring-before($filename_index, '#'), '#', $indexID)"/>
                        </xsl:when>
                        <xsl:otherwise>
                          <xsl:value-of select="concat($filename_index, '#', $indexID)"/>
                        </xsl:otherwise>
                      </xsl:choose>
                    </xsl:for-each>
                  </xsl:attribute>
                  <xsl:choose>
                    <xsl:when test="@mainEntry='yes'">
                      <b>
                        <xsl:text>--></xsl:text>
                      </b>
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:text>--></xsl:text>
                    </xsl:otherwise>
                  </xsl:choose>
                </a>
                <xsl:if test="not(position()=last())">
                  <xsl:text>, </xsl:text>
                </xsl:if>
              </xsl:for-each>
            </li>
          </xsl:for-each-group>
        </ul>
      </xsl:when>
      <xsl:when test="name(.)='furtherReading'">
        <xsl:choose>
          <xsl:when test="@sorting='off'">
            <ul class="furtherReading">
              <xsl:for-each select="elml:resItem">
                <xsl:apply-templates
                  select="/elml:lesson/elml:bibliography/*[@bibID=current()/@bibIDRef]">
                  <xsl:with-param name="comment" select="text()"/>
                  <xsl:with-param name="furtherReading" select="@bibIDRef"/>
                  <xsl:with-param name="pageNr" select="@pageNr"/>
                </xsl:apply-templates>
              </xsl:for-each>
            </ul>
          </xsl:when>
          <xsl:when test="@sorting='byYear'">
            <ul class="furtherReading">
              <xsl:for-each select="elml:resItem">
                <xsl:sort
                  select="/elml:lesson/elml:bibliography/*[@bibID=current()/@bibIDRef]/@publicationYear"
                  order="descending" lang="{$lang}"/>
                <xsl:sort
                  select="/elml:lesson/elml:bibliography/*[@bibID=current()/@bibIDRef]/@accessedDate"
                  order="descending" lang="{$lang}"/>
                <xsl:apply-templates
                  select="/elml:lesson/elml:bibliography/*[@bibID=current()/@bibIDRef]">
                  <xsl:with-param name="comment" select="text()"/>
                  <xsl:with-param name="furtherReading" select="@bibIDRef"/>
                  <xsl:with-param name="pageNr" select="@pageNr"/>
                </xsl:apply-templates>
              </xsl:for-each>
            </ul>
          </xsl:when>
          <xsl:when test="@sorting='groupByType'">
            <xsl:for-each-group select="elml:resItem/@bibIDRef"
              group-by="/elml:lesson/elml:bibliography/*[@bibID=current()]/name()">
              <xsl:sort select="/elml:lesson/elml:bibliography/*[@bibID=current()]/name()"
                order="ascending" lang="{$lang}"/>
              <h2>
                <xsl:call-template name="elml:name_biblio">
                  <xsl:with-param name="itemname"
                    select="name(/elml:lesson/elml:bibliography/*[@bibID=current()])"/>
                </xsl:call-template>
              </h2>
              <ul class="furtherReading">
                <xsl:for-each select="current-group()">
                  <xsl:sort select="/elml:lesson/elml:bibliography/*[@bibID=current()]/@author"
                    order="ascending" lang="{$lang}"/>
                  <xsl:apply-templates select="/elml:lesson/elml:bibliography/*[@bibID=current()]">
                    <xsl:with-param name="comment" select="../text()"/>
                    <xsl:with-param name="furtherReading" select="current()"/>
                    <xsl:with-param name="pageNr" select="../@pageNr"/>
                  </xsl:apply-templates>
                </xsl:for-each>
              </ul>
            </xsl:for-each-group>
          </xsl:when>
          <xsl:when test="@sorting='groupByYear'">
            <xsl:for-each-group select="elml:resItem/@bibIDRef"
              group-by="/elml:lesson/elml:bibliography/*[@bibID=current()]/@publicationYear">
              <xsl:sort select="/elml:lesson/elml:bibliography/*[@bibID=current()]/@publicationYear"
                order="descending" lang="{$lang}"/>
              <h2>
                <xsl:value-of
                  select="/elml:lesson/elml:bibliography/*[@bibID=current()]/@publicationYear"/>
              </h2>
              <ul class="furtherReading">
                <xsl:for-each select="current-group()">
                  <xsl:sort select="/elml:lesson/elml:bibliography/*[@bibID=current()]/@author"/>
                  <xsl:apply-templates select="/elml:lesson/elml:bibliography/*[@bibID=current()]">
                    <xsl:with-param name="comment" select="../text()"/>
                    <xsl:with-param name="furtherReading" select="current()"/>
                    <xsl:with-param name="pageNr" select="../@pageNr"/>
                  </xsl:apply-templates>
                </xsl:for-each>
              </ul>
            </xsl:for-each-group>
          </xsl:when>
          <xsl:otherwise>
            <ul class="furtherReading">
              <xsl:for-each select="elml:resItem">
                <xsl:sort
                  select="/elml:lesson/elml:bibliography/*[@bibID=current()/@bibIDRef]/@author"
                  order="ascending" lang="{$lang}"/>
                <xsl:apply-templates
                  select="/elml:lesson/elml:bibliography/*[@bibID=current()/@bibIDRef]">
                  <xsl:with-param name="comment" select="text()"/>
                  <xsl:with-param name="furtherReading" select="@bibIDRef"/>
                  <xsl:with-param name="pageNr" select="@pageNr"/>
                </xsl:apply-templates>
              </xsl:for-each>
            </ul>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:when test="name(.)='bibliography'">
        <xsl:choose>
          <xsl:when test="@sorting='off'">
            <ul class="bibliography">
              <xsl:apply-templates/>
            </ul>
          </xsl:when>
          <xsl:when test="@sorting='byYear'">
            <ul class="bibliography">
              <xsl:apply-templates>
                <xsl:sort select="@publicationYear" order="descending" lang="{$lang}"/>
                <xsl:sort select="@accessedDate" order="descending" lang="{$lang}"/>
              </xsl:apply-templates>
            </ul>
          </xsl:when>
          <xsl:when test="@sorting='groupByType'">
            <xsl:for-each-group select="node()" group-by="name()">
              <xsl:sort select="name()" order="ascending" lang="{$lang}"/>
              <h2>
                <xsl:call-template name="elml:name_biblio">
                  <xsl:with-param name="itemname" select="name()"/>
                </xsl:call-template>
              </h2>
              <ul class="bibliography">
                <xsl:apply-templates select="current-group()">
                  <xsl:sort select="@author" order="ascending" lang="{$lang}"/>
                </xsl:apply-templates>
              </ul>
            </xsl:for-each-group>
          </xsl:when>
          <xsl:when test="@sorting='groupByYear'">
            <xsl:for-each-group select="node()" group-by="@publicationYear">
              <xsl:sort select="@publicationYear" order="descending" lang="{$lang}"/>
              <h2>
                <xsl:value-of select="@publicationYear"/>
              </h2>
              <ul class="bibliography">
                <xsl:apply-templates select="current-group()">
                  <xsl:sort select="@author" order="ascending" lang="{$lang}"/>
                </xsl:apply-templates>
              </ul>
            </xsl:for-each-group>
          </xsl:when>
          <xsl:otherwise>
            <ul class="bibliography">
              <xsl:apply-templates>
                <xsl:sort select="@author" order="ascending" lang="{$lang}"/>
              </xsl:apply-templates>
            </ul>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:when test="name(.)='goals'">
        <xsl:choose>
          <xsl:when test="@presentation='table'">
            <table class="goals">
              <xsl:if test="@intStatement">
                <tr>
                  <th align="left">
                    <xsl:value-of select="@intStatement"/>
                  </th>
                </tr>
              </xsl:if>
              <xsl:for-each select="elml:lObjective">
                <xsl:if test="(@role='student') or (@role=$role) or (not (@role))">
                  <tr>
                    <xsl:call-template name="elml:CSS_Class"/>
                    <td>
                      <xsl:apply-templates/>
                    </td>
                  </tr>
                </xsl:if>
              </xsl:for-each>
            </table>
          </xsl:when>
          <xsl:otherwise>
            <xsl:if test="@intStatement">
              <p class="paragraph">
                <xsl:value-of select="@intStatement"/>
              </p>
            </xsl:if>
            <ul class="goals">
              <xsl:for-each select="elml:lObjective">
                <xsl:if test="(@role='student') or (@role=$role) or (not (@role))">
                  <li>
                    <xsl:call-template name="elml:CSS_Class"/>
                    <xsl:apply-templates/>
                  </li>
                </xsl:if>
              </xsl:for-each>
            </ul>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="elml:metasetupinfo"/>
        <xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="elml:learningObject">
    <xsl:param name="filename">
      <xsl:call-template name="elml:Label_param"/>
    </xsl:param>
    <xsl:choose>
      <xsl:when
        test="$pagebreak_level='lo' and (name(preceding-sibling::*[1])='learningObject' or name(following-sibling::*[1])='learningObject')">
        <xsl:result-document href="{elml:get_pathHTML(base-uri(),/elml:lesson/@label)}{$filename}"
          format="online">
          <html>
            <xsl:call-template name="elml:LayoutHead"/>
            <xsl:call-template name="elml:LayoutBody"/>
          </html>
        </xsl:result-document>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="elml:LayoutBodyContent"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <!-- redefinition of elml:next_file and elml:prev_file -->
  <xsl:template name="elml:next_file">
    <xsl:param name="Label_param_temp">
      <xsl:choose>
        <!-- rvw: fix for invisible glossary: "normal" unit -->
        <xsl:when
          test="(name(.)='learningObject') and not(following-sibling::*[1]) and (name(../following-sibling::*[1])='glossary') and (../following-sibling::*[1]/@visible='none')">
          <xsl:text>none</xsl:text>
        </xsl:when>
        <!-- rvw: fix for invisible glossary: unit with only 1 LO -->
        <xsl:when
          test="(name(.)='unit') and (name(child::*[1]) = 'learningObject') and (name(following-sibling::*[1])='glossary') and (following-sibling::*[1]/@visible='none')">
          <xsl:text>none</xsl:text>
        </xsl:when>
        <!-- rvw: fix - when unit with 1 LO is last unit in lesson -->
        <xsl:when
          test="(name(.)='unit') and not(following-sibling::*[1]) and count(elml:learningObject)=1">
          <xsl:text>none</xsl:text>
        </xsl:when>
        <xsl:when test="$pagebreak_level='lesson'">
          <xsl:text>none</xsl:text>
        </xsl:when>
        <xsl:when test="name(.)='lesson'">
          <xsl:text>unit_</xsl:text>
          <xsl:value-of select="elml:unit[1]/@label"/>
        </xsl:when>
        <xsl:when
          test="not(following::*[1]) and ($pagebreak_level='unit' or ($pagebreak_level='lo' and not(name(.)='unit')))">
          <xsl:text>none</xsl:text>
        </xsl:when>
        <xsl:when test="name(.)='index'">
          <xsl:choose>
            <xsl:when
              test="/elml:lesson/elml:metadata and ($role='tutor' or /elml:lesson/elml:metadata/@role=$role or not(/elml:lesson/elml:metadata/@role)) and not(/elml:lesson/elml:metadata/@visible='none') and not(/elml:lesson/elml:metadata/@visible='print')">
              <xsl:value-of select="/elml:lesson/@label"/>
              <xsl:text>_</xsl:text>
              <xsl:text>metadata</xsl:text>
            </xsl:when>
            <xsl:otherwise>
              <xsl:text>none</xsl:text>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <xsl:when test="name(.)='bibliography'">
          <xsl:choose>
            <xsl:when
              test="/elml:lesson/elml:index and not(/elml:lesson/elml:index/@visible='none') and not(/elml:lesson/elml:index/@visible='print')">
              <xsl:value-of select="/elml:lesson/@label"/>
              <xsl:text>_</xsl:text>
              <xsl:text>index</xsl:text>
            </xsl:when>
            <xsl:when
              test="/elml:lesson/elml:metadata and ($role='tutor' or /elml:lesson/elml:metadata/@role=$role or not(/elml:lesson/elml:metadata/@role)) and not(/elml:lesson/elml:metadata/@visible='none') and not(/elml:lesson/elml:metadata/@visible='print')">
              <xsl:value-of select="/elml:lesson/@label"/>
              <xsl:text>_</xsl:text>
              <xsl:text>metadata</xsl:text>
            </xsl:when>
            <xsl:otherwise>
              <xsl:text>none</xsl:text>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <xsl:when test="name(.)='metadata'">
          <xsl:text>none</xsl:text>
        </xsl:when>
        <xsl:when
          test="not(following-sibling::*[1]) and (name(parent::*)='lesson') and (name(.)='bibliography' or name(.)='glossary' or name(.)='furtherReading' or name(.)='summary' or name(.)='selfAssessment' or name(.)='listOfFigures' or name(.)='listOfTables' or name(.)='index')">
          <xsl:text>none</xsl:text>
        </xsl:when>
        <xsl:when
          test="$pagebreak_level='unit' or (name(.)='unit' and count(elml:learningObject)=1)">
          <xsl:choose>
            <xsl:when
              test="name(following-sibling::*[1]) = 'unit' and (not(following-sibling::*[1]/@role) or following-sibling::*[1]/@role=$role or following-sibling::*[1]/@role='student')">
              <xsl:text>unit</xsl:text>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="../@label"/>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:text>_</xsl:text>
          <xsl:choose>
            <xsl:when
              test="following-sibling::*[1]/@visible='none' or following-sibling::*[1]/@visible='print' or (following-sibling::*[1]/@role and not(following-sibling::*[1]/@role=$role or following-sibling::*[1]/@role='student'))">
              <xsl:value-of select="name(following-sibling::*[2])"/>
              <xsl:if test="name(following-sibling::*[2])='selfAssessment'">
                <xsl:text>1</xsl:text>
              </xsl:if>
            </xsl:when>
            <xsl:when test="following-sibling::*[1]/@label">
              <xsl:value-of select="following-sibling::*[1]/@label"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="name(following-sibling::*[1])"/>
              <xsl:if test="name(following-sibling::*[1])='selfAssessment'">
                <xsl:number
                  value="count(preceding-sibling::*[name(.)='selfAssessment'])+count(self::*[name(.)='selfAssessment'])+1"
                />
              </xsl:if>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <xsl:when test="$pagebreak_level='lo'">
          <xsl:choose>
            <xsl:when test="name(.)='unit'">
              <xsl:value-of select="@label"/>
            </xsl:when>
            <xsl:when
              test="not(following-sibling::*[1]) and (name(parent::*/following-sibling::*[1])='unit' and (parent::*/following-sibling::*[1]/@role=$role or parent::*/following-sibling::*[1]/@role='student' or not(parent::*/following-sibling::*[1]/@role)))">
              <xsl:text>unit</xsl:text>
            </xsl:when>
            <xsl:when test="not(following-sibling::*[1])">
              <xsl:value-of select="/elml:lesson/@label"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="../@label"/>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:text>_</xsl:text>
          <xsl:choose>
            <xsl:when test="name(.)='unit'">
              <xsl:choose>
                <xsl:when test="elml:learningObject[1]/@label">
                  <xsl:value-of select="elml:learningObject[1]/@label"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>learningObject1</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:when>
            <xsl:when test="following-sibling::*[1]/@label">
              <xsl:value-of select="following-sibling::*[1]/@label"/>
            </xsl:when>
            <xsl:when test="name(following-sibling::*[1])='selfAssessment'">
              <xsl:value-of select="name(following-sibling::*[1])"/>
              <xsl:number
                value="count(preceding-sibling::*[name(.)='learningObject'])+count(self::*[name(.)='learningObject'])+count(preceding-sibling::*[name(.)='selfAssessment'])+count(self::*[name(.)='selfAssessment'])+1"
              />
            </xsl:when>
            <xsl:when test="name(following-sibling::*[1])='learningObject'">
              <xsl:value-of select="name(following-sibling::*[1])"/>
              <xsl:number
                value="count(preceding-sibling::*[name(.)='learningObject'])+count(self::*[name(.)='learningObject'])+1"
              />
            </xsl:when>
            <xsl:when test="not(following-sibling::*[1])">
              <xsl:choose>
                <xsl:when
                  test="parent::*/following-sibling::*[1]/@role and not(parent::*/following-sibling::*[1]/@role=$role or parent::*/following-sibling::*[1]/@role='student')">
                  <xsl:value-of select="name(parent::*/following-sibling::*[2])"/>
                  <xsl:if test="name(parent::*/following-sibling::*[2])='selfAssessment'">
                    <xsl:text>1</xsl:text>
                  </xsl:if>
                </xsl:when>
                <xsl:when test="parent::*/following-sibling::*[1]/@label">
                  <xsl:value-of select="parent::*/following-sibling::*[1]/@label"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="name(parent::*/following-sibling::*[1])"/>
                  <xsl:if test="name(parent::*/following-sibling::*[1])='selfAssessment'">
                    <xsl:text>1</xsl:text>
                  </xsl:if>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="name(following-sibling::*[1])"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
      </xsl:choose>
      <xsl:value-of select="$filename_suffix"/>
    </xsl:param>
    <xsl:value-of
      select="string(concat($Label_param_temp[1],$Label_param_temp[2],$Label_param_temp[3],$Label_param_temp[4],$Label_param_temp[5],$Label_param_temp[6],$Label_param_temp[7],$Label_param_temp[8],$Label_param_temp[9],$Label_param_temp[10],$Label_param_temp[11],$Label_param_temp[12]))"
    />
  </xsl:template>
  <!-- name="elml:next_file" -->

  <xsl:template name="elml:prev_file">
    <xsl:param name="Label_param_temp">
      <xsl:choose>
        <xsl:when test="name(.)='lesson'">
          <xsl:text>none</xsl:text>
        </xsl:when>

        <xsl:when
          test="(name(.)='unit') and (name(preceding-sibling::*[1])='goals' or name(preceding-sibling::*[1])='entry' or (preceding-sibling::*[1]/@role and not(preceding-sibling::*[1]/@role=$role or preceding-sibling::*[1]/@role='student')))">
          <xsl:text>index</xsl:text>
        </xsl:when>

        <!-- here the check for units with only one LO is done -->
        <xsl:when
          test="$pagebreak_level='unit' or (name(.)='unit' and count(preceding-sibling::elml:unit[1]/elml:learningObject)=1) or (name(.)='glossary' and count(preceding-sibling::elml:unit[1]/elml:learningObject)=1)">
          <xsl:choose>
            <xsl:when test="name(preceding-sibling::*[1]) = 'unit'">
              <xsl:text>unit</xsl:text>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="../@label"/>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:text>_</xsl:text>
          <xsl:choose>
            <xsl:when
              test="preceding-sibling::*[1]/@role and not(preceding-sibling::*[1]/@role=$role or preceding-sibling::*[1]/@role='student')">
              <xsl:value-of select="preceding-sibling::*[2]/@label"/>
            </xsl:when>
            <xsl:when test="preceding-sibling::*[1]/@label">
              <xsl:value-of select="preceding-sibling::*[1]/@label"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="name(preceding-sibling::*[1])"/>
              <xsl:if
                test="name(preceding-sibling::*[1])='selfAssessment' or name(preceding-sibling::*[1])='learningObject'">
                <xsl:number value="count(preceding-sibling::*[name(.)='selfAssessment'])"/>
              </xsl:if>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <!-- test="$pagebreak_level='unit'... -->

        <xsl:when test="$pagebreak_level='lo'">
          <xsl:choose>
            <xsl:when
              test="(name(preceding-sibling::*[1]) = 'entry') or (name(preceding-sibling::*[1]) = 'goals') or not(preceding-sibling::*[1])">
              <xsl:text>unit</xsl:text>
            </xsl:when>

            <xsl:when
              test="preceding-sibling::*[1]/@role and not(preceding-sibling::*[1]/@role=$role or preceding-sibling::*[1]/@role='student')">
              <xsl:value-of select="preceding-sibling::*[2]/@label"/>
            </xsl:when>

            <xsl:when test="name(preceding-sibling::*[1]) = 'unit'">
              <xsl:value-of select="preceding-sibling::*[1]/@label"/>
            </xsl:when>

            <xsl:otherwise>
              <xsl:value-of select="../@label"/>
            </xsl:otherwise>
          </xsl:choose>

          <xsl:text>_</xsl:text>

          <xsl:choose>
            <xsl:when test="name(preceding-sibling::*[1])='unit'">
              <xsl:choose>
                <xsl:when
                  test="preceding-sibling::*[1]/@role and not(preceding-sibling::*[1]/@role=$role or preceding-sibling::*[1]/@role='student')">
                  <xsl:choose>
                    <xsl:when test="preceding-sibling::*[2]/child::*[last()]/@label">
                      <xsl:value-of select="preceding-sibling::*[2]/child::*[last()]/@label"/>
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:value-of select="name(preceding-sibling::*[2]/child::*[last()])"/>
                      <xsl:if
                        test="(name(preceding-sibling::*[2]/child::*[last()])='learningObject') or (name(preceding-sibling::*[2]/child::*[last()])='selfAssessment')">
                        <xsl:number
                          value="count(preceding-sibling::*[2]/child::*[name(.)='learningObject'])+count(preceding-sibling::*[2]/child::*[name(.)='selfAssessment'])"
                        />
                      </xsl:if>
                    </xsl:otherwise>
                  </xsl:choose>
                </xsl:when>
                <xsl:when test="preceding-sibling::*[1]/child::*[last()]/@label">
                  <xsl:value-of select="preceding-sibling::*[1]/child::*[last()]/@label"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="name(preceding-sibling::*[1]/child::*[last()])"/>
                  <xsl:if
                    test="(name(preceding-sibling::*[1]/child::*[last()])='learningObject') or (name(preceding-sibling::*[1]/child::*[last()])='selfAssessment')">
                    <xsl:number
                      value="count(preceding-sibling::*[1]/child::*[name(.)='learningObject'])+count(preceding-sibling::*[1]/child::*[name(.)='selfAssessment'])"
                    />
                  </xsl:if>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:when>

            <xsl:when
              test="(name(preceding-sibling::*[1]) = 'entry') or (name(preceding-sibling::*[1]) = 'goals') or not(preceding-sibling::*[1])">
              <xsl:value-of select="../@label"/>
            </xsl:when>

            <xsl:when test="preceding-sibling::*[1]/@label">
              <xsl:value-of select="preceding-sibling::*[1]/@label"/>
            </xsl:when>

            <xsl:otherwise>
              <xsl:value-of select="name(preceding-sibling::*[1])"/>
              <xsl:if
                test="name(preceding-sibling::*[1])='selfAssessment' or name(preceding-sibling::*[1])='learningObject'">
                <xsl:number
                  value="count(preceding-sibling::*[name(.)='learningObject'])+count(preceding-sibling::*[name(.)='selfAssessment'])"
                />
              </xsl:if>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <!-- test="$pagebreak_level='lo'" -->
      </xsl:choose>

      <xsl:value-of select="$filename_suffix"/>
    </xsl:param>
    <xsl:value-of
      select="string(concat($Label_param_temp[1],$Label_param_temp[2],$Label_param_temp[3],$Label_param_temp[4],$Label_param_temp[5],$Label_param_temp[6],$Label_param_temp[7],$Label_param_temp[8],$Label_param_temp[9],$Label_param_temp[10],$Label_param_temp[11],$Label_param_temp[12]))"
    />
  </xsl:template>
  <!-- name="elml:prev_file" -->
  <!-- RvW: imported from core and modified END -->

  <xsl:template name="elml:display">
    <xsl:choose>
      <xsl:when
        test="name()='learningObject' and $pagebreak_level='lo' and not(name(preceding-sibling::*[1])='learningObject') and not(name(following-sibling::*[1])='learningObject')">
        <xsl:text>no</xsl:text>
      </xsl:when>
      <xsl:when
        test="((@role='student') or (@role=$role) or (not (@role))) and not(@visible='print') and not(@visible='none')">
        <xsl:text>yes</xsl:text>
      </xsl:when>
      <xsl:otherwise>no</xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="elml:CSS_Class">
    <xsl:attribute name="class">
      <xsl:choose>
        <xsl:when test="@role='tutor'">
          <xsl:value-of select="@role"/>
        </xsl:when>
        <xsl:when test="@cssClass">
          <xsl:value-of select="@cssClass"/>
        </xsl:when>
        <xsl:when
          test="@icon='act' or @icon='important' or @icon='look' or @icon='question' or @icon='remark'">
          <xsl:value-of select="name()"/>
          <xsl:text>_</xsl:text>
          <xsl:value-of select="@icon"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="name()"/>
          <!-- alternating rows -->
          <xsl:if
            test="(position() mod 2 != 0) and (name()='tablerow' or name()='lObjective' or name()='item')">
            <xsl:text>Alt</xsl:text>
          </xsl:if>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:attribute>
  </xsl:template>
</xsl:stylesheet>
